/*
 * Copyright (c) 2003-2004, by Boris Popov
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice unmodified, this list of conditions, and the following
 *    disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * $TenDRA: tendra/src/include/tenapp.h,v 1.3 2004/05/01 14:21:06 stefanf Exp $
 */

#ifndef TEN_TENAPP_H
#define TEN_TENAPP_H

/*
 * Type of app exit handler
 */
typedef void tenapp_eh_t (void);

extern const char *progdesc;
extern const char *progname;
extern const char *progvers;
extern const char *relvers;
extern const char *last_command;
extern int exit_status;
extern int tenapp_print_memusage_onexit;

void tenapp_add_eh(tenapp_eh_t *);
void tenapp_checkerrors(int);
void tenapp_exit(void);
void tenapp_exit2(int);
void tenapp_init(int, char *[], const char *, const char *);
void set_progname(const char *);
void tenapp_report_version(void);
void tenapp_signal(int);


#endif /* !defined(TEN_TENAPP_H) */

