/*
 * Copyright (c) 2002, The Tendra Project <http://www.ten15.org/>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice unmodified, this list of conditions, and the following
 *    disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *
 *    		 Crown Copyright (c) 1997
 *    
 *    This TenDRA(r) Computer Program is subject to Copyright
 *    owned by the United Kingdom Secretary of State for Defence
 *    acting through the Defence Evaluation and Research Agency
 *    (DERA).  It is made available to Recipients with a
 *    royalty-free licence for its use, reproduction, transfer
 *    to other parties and amendment for any purpose not excluding
 *    product development provided that any such use et cetera
 *    shall be deemed to be acceptance of the following conditions:-
 *    
 *        (1) Its Recipients shall ensure that this Notice is
 *        reproduced upon any copies or amended versions of it;
 *    
 *        (2) Any amended version of it shall be clearly marked to
 *        show both the nature of and the organisation responsible
 *        for the relevant amendment or amendments;
 *    
 *        (3) Its onward transfer from a recipient to another
 *        party shall be deemed to be that party's acceptance of
 *        these conditions;
 *    
 *        (4) DERA gives no warranty or assurance as to its
 *        quality or suitability for any purpose and DERA accepts
 *        no liability whatsoever in relation to any use to which
 *        it may be put.
 *
 * $TenDRA: tendra/src/installers/mips/common/inst_fmt.h,v 1.6 2004/06/28 03:31:05 bp Exp $
 */


/* inst_fmtdecs.h
 *    procs for outputting various MIPS instruction formats to external files
 *    as_file and ba_file
 */

#include "addrtypes.h" 


extern void ls_ins(char *ins, int reg, baseoff a);
extern void mon_ins(char *ins, int dest, int src);
extern void rrr_ins(char *ins, int dest, int src1, int src2);
extern void rri_ins(char *ins, int dest, int src1, long imm);
extern void uncond_ins(char *ins, int lab);
extern void condrr_ins(char *ins, int src1, int src2, int lab);
extern void condri_ins(char *ins, int src1, long imm, int lab);
extern void condr_ins(char *ins, int src1, int lab);
extern void cop_ins(char *ins, int gr, int fr);
extern void lsfp_ins(char *ins, int reg, baseoff a);
extern void rrfp_ins(char *ins, int dest, int src);
extern void rrfpcond_ins(char *ins, int dest, int src);
extern void rrrfp_ins(char *ins, int dest, int src1, int src2);
extern void ri_ins(char *ins, int dest, long imm);
extern void br_ins(char *ins, int dest);
extern void extj_ins(char *ins, baseoff b);
extern void tround_ins(char *ins, int dfr, int sfr, int gpr);
extern void multdiv_ins(char *ins, int r1, int r2);
extern void hilo_ins(char * ins, int dest);
