#   		 Crown Copyright (c) 1997
#   
#   This TenDRA(r) Computer Program is subject to Copyright
#   owned by the United Kingdom Secretary of State for Defence
#   acting through the Defence Evaluation and Research Agency
#   (DERA).  It is made available to Recipients with a
#   royalty-free licence for its use, reproduction, transfer
#   to other parties and amendment for any purpose not excluding
#   product development provided that any such use et cetera
#   shall be deemed to be acceptance of the following conditions:-
#   
#       (1) Its Recipients shall ensure that this Notice is
#       reproduced upon any copies or amended versions of it;
#   
#       (2) Any amended version of it shall be clearly marked to
#       show both the nature of and the organisation responsible
#       for the relevant amendment or amendments;
#   
#       (3) Its onward transfer from a recipient to another
#       party shall be deemed to be that party's acceptance of
#       these conditions;
#   
#       (4) DERA gives no warranty or assurance as to its
#       quality or suitability for any purpose and DERA accepts
#       no liability whatsoever in relation to any use to which
#       it may be put.
#
# Strictly, according to 1.6.1 the value of each String constant of the
# form XtN..., XtC... or XtR... is known.  It is the result of removing
# the prefix.  However we have prefered to leave them undefined.

+USE "x5/t", "X11/Intrinsic.h" ;


# Defined Strings (Appendix E etc)

+CONST String XtNaccelerators, XtNallowHoriz, XtNallowVert ;
+CONST String XtNancestorSensitive, XtNbackground, XtNbackgroundPixmap ;
+CONST String XtNbitmap, XtNborder, XtNborderColor, XtNborderPixmap ;
+CONST String XtNborderWidth, XtNcallback, XtNchildren, XtNcolormap ;
+CONST String XtNdepth, XtNdestroyCallback, XtNeditType, XtNfile ;
+CONST String XtNfont, XtNfontSet, XtNforceBars, XtNforeground ;
+CONST String XtNfunction, XtNhSpace, XtNheight, XtNhighlight ;
+CONST String XtNindex, XtNinitialResourcesPersistent, XtNinnerHeight ;
+CONST String XtNinnerWidth, XtNinnerWindow, XtNinsertPosition ;
+CONST String XtNinternalHeight, XtNinternalWidth, XtNjumpProc ;
+CONST String XtNjustify, XtNknobHeight, XtNknobIndent, XtNknobPixel ;
+CONST String XtNknobWidth, XtNlabel, XtNlength, XtNlowerRight ;
+CONST String XtNmappedWhenManaged, XtNmenuEntry, XtNname, XtNnotify ;
+CONST String XtNnumChildren, XtNorientation, XtNparameter, XtNpixmap ;
+CONST String XtNpopdownCallback, XtNpopupCallback, XtNresize ;
+CONST String XtNreverseVideo, XtNscreen, XtNscrollDCursor ;
+CONST String XtNscrollHCursor, XtNscrollLCursor, XtNscrollProc ;
+CONST String XtNscrollRCursor, XtNscrollUCursor, XtNscrollVCursor ;
+CONST String XtNselection, XtNselectionArray, XtNsensitive, XtNshown ;
+CONST String XtNspace, XtNstring, XtNtextOptions, XtNtextSink ;
+CONST String XtNtextSource, XtNthickness, XtNthumb, XtNthumbProc ;
+CONST String XtNtop, XtNtranslations, XtNunrealizeCallback, XtNupdate ;
+CONST String XtNuseBottom, XtNuseRight, XtNvSpace, XtNvalue ;
+CONST String XtNwidth, XtNwindow, XtNx, XtNy ;

+CONST String XtCAccelerators, XtCBackground, XtCBitmap, XtCBoolean ;
+CONST String XtCBorderColor, XtCBorderWidth, XtCCallback, XtCColor ;
+CONST String XtCColormap, XtCCursor, XtCDepth, XtCEditType ;
+CONST String XtCEventBindings, XtCFile, XtCFont, XtCFontSet ;
+CONST String XtCForeground, XtCFraction, XtCFunction, XtCHSpace ;
+CONST String XtCHeight, XtCIndex, XtCInitialResourcesPersistent ;
+CONST String XtCInsertPosition, XtCInterval, XtCJustify, XtCKnobIndent ;
+CONST String XtCKnobPixel, XtCLabel, XtCLength, XtCMappedWhenManaged ;
+CONST String XtCMargin, XtCMenuEntry, XtCNotify, XtCOrientation ;
+CONST String XtCParameter, XtCPixmap, XtCPosition, XtCReadOnly ;
+CONST String XtCResize, XtCReverseVideo, XtCScreen, XtCScrollDCursor ;
+CONST String XtCScrollHCursor, XtCScrollLCursor, XtCScrollProc ;
+CONST String XtCScrollRCursor, XtCScrollUCursor, XtCScrollVCursor ;
+CONST String XtCSelection, XtCSelectionArray, XtCSensitive, XtCSpace ;
+CONST String XtCString, XtCTextOptions, XtCTextPosition, XtCTextSink ;
+CONST String XtCTextSource, XtCThickness, XtCThumb, XtCTranslations ;
+CONST String XtCVSpace, XtCValue, XtCWidth, XtCWindow, XtCX, XtCY ;

+CONST String XtRAcceleratorTable, XtRAtom, XtRBitmap, XtRBool ;
+CONST String XtRBoolean, XtRCallProc, XtRCallback, XtRCardinal, XtRColor ;
+CONST String XtRColormap, XtRCursor, XtRDimension, XtRDisplay, XtREditMode ;
+CONST String XtREnum, XtRFile, XtRFloat, XtRFont, XtRFontSet, XtRFontStruct ;
+CONST String XtRFunction, XtRGeometry, XtRImmediate, XtRInitialState ;
+CONST String XtRInt, XtRJustify, XtRLongBoolean, XtRObject, XtROrientation ;
+CONST String XtRPixel, XtRPixmap, XtRPointer, XtRPosition, XtRScreen ;
+CONST String XtRShort, XtRString, XtRStringArray, XtRStringTable ;
+CONST String XtRTranslationTable, XtRUnsignedChar, XtRVisual, XtRWidget ;
+CONST String XtRWidgetClass, XtRWidgetList, XtRWindow ;

+CONST String XtEoff, XtEfalse, XtEno, XtEon, XtEtrue, XtEyes ;
+CONST String XtEvertical, XtEhorizontal ;
+CONST String XtEtextRead, XtEtextAppend, XtEtextEdit ;
+CONST String XtExtdefaultbackground, XtExtdefaultforeground ;
+CONST String XtExtdefaultfont ;
