/*
 * Copyright (c) 2002, The Tendra Project <http://www.ten15.org/>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice unmodified, this list of conditions, and the following
 *    disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *
 *    		 Crown Copyright (c) 1997
 *
 *    This TenDRA(r) Computer Program is subject to Copyright
 *    owned by the United Kingdom Secretary of State for Defence
 *    acting through the Defence Evaluation and Research Agency
 *    (DERA).  It is made available to Recipients with a
 *    royalty-free licence for its use, reproduction, transfer
 *    to other parties and amendment for any purpose not excluding
 *    product development provided that any such use et cetera
 *    shall be deemed to be acceptance of the following conditions:-
 *
 *        (1) Its Recipients shall ensure that this Notice is
 *        reproduced upon any copies or amended versions of it;
 *
 *        (2) Any amended version of it shall be clearly marked to
 *        show both the nature of and the organisation responsible
 *        for the relevant amendment or amendments;
 *
 *        (3) Its onward transfer from a recipient to another
 *        party shall be deemed to be that party's acceptance of
 *        these conditions;
 *
 *        (4) DERA gives no warranty or assurance as to its
 *        quality or suitability for any purpose and DERA accepts
 *        no liability whatsoever in relation to any use to which
 *        it may be put.
 *
 * $TenDRA: tendra/src/tools/disp/basic.h,v 1.8 2005/11/05 12:03:14 stefanf Exp $
 */


#ifndef BASIC_INCLUDED
#define BASIC_INCLUDED


/*
 *    BASIC TDF DECODING ROUTINES
 *
 *    This file contains the basic decoding routines for TDF integers,
 *    strings etc.
 */

struct tdf_string;

extern external de_extern_name(void);
extern sortid de_sort_name(int);
extern string de_tdfstring(void);
extern string de_tdfstring_align(void);
extern unique de_unique(void);
extern TDFINTL tdf_int(void);
extern char *tdf_int_str(void);
extern char *tdf_string_format(struct tdf_string *);
extern void add_foreign_sort(char *, char *, int);
extern int tdf_int_digits;
extern sortid *foreign_sorts;
extern long no_foreign_sorts;
extern int do_foreign_sorts;

#define tdf_bool()		(tdf_de_tdfbool(tdfr))

#define check_list()\
	if (tdf_de_bits (tdfr, 1)) {\
		out ("<error>");\
		MSG_illegal_LIST_value ();\
	}


/*
 *    START OF EXTRA SORTS
 *
 *    Normal TDF sorts are represented by small values (see tdf.h).  Foreign
 *    sorts are represented by values starting at extra_sorts.
 */

#define extra_sorts     100


#endif
